select
    an.numero as numero
    , an.nome as nome
    , (select grausangue from sp_calculagrausangue(an.cdanimal)) as raca_animal
    , se.nome as setor_atual
    , cob.data as data_insemincao
    , (case cob.cdtiporeproducao when 1 then 'Inseminacao' when 2 then 'Cobertura' when 3 then 'Transferncia de embrio'
        else null end) as tipo_fecundacao 
    , (select count(*) from reproducao re where re.cdtiporeproducao = 7 and re.cdanimal = an.cdanimal) as ordem_parto
    , par.data as data_parto
    , tp.descricao as tipo_parto
    , (par.data - cob.data) as duracao_gestacao
    , (select count(*) from reproducao re where re.cdtiporeproducao in (1,2,3) and re.cdanimal = an.cdanimal and re.data > coalesce(par.data, '1900-01-01')) as ordem_tentativa
from            
    animal an
    left join reproducao par on par.cdreproducao =
        (select first 1 re.cdreproducao from reproducao re where re.cdtiporeproducao = 7 and re.cdanimal = an.cdanimal order by re.data desc)
    left join tipoparto tp on tp.cdtipoparto = par.cdtipoparto
    left join reproducao cob on cob.cdreproducao =
        (select first 1 re.cdreproducao from reproducao re where re.cdtiporeproducao in (1,2,3) and re.cdanimal = an.cdanimal and re.data < par.data order by re.data desc)
    left join setor se on se.cdsetor = an.cdsetor
where
    an.tipoanimal = 'A'
    and an.animalrebanho = 1
    and an.dtbaixa is null
    and an.cdcategoria = '7'
order by
    an.numordenado
    


